Subject: 24.3.92; A combination of `display' on text and `invisible' and `before/after-string' leads to the before/after string being displayed twice

From: Dmitry <[email-masked]>
Date: Mon, 18 Aug 2014 02:35:06 +0400

(let ((pt (point)))
  (insert (propertize "a" 'display "bbb"))
  (let ((o (make-overlay pt (point))))
    (overlay-put o 'invisible t)
    (overlay-put o 'after-string "foo\nbar")))

The result looks like this:

foo
barbbbfoo
bar

It's the same if I use `before-string' instead of `after-string', but
not `display'.

If I don't set the `invisible' property, it's just

bbbfoo
bar

If I replace (make-overlay pt (point)) with (make-overlay (1- pt)
(point)), the result it, expectedly:

foo
bar

This bug is present in Emacs 24.3, too (so not a regression).

In GNU Emacs 24.3.92.4 (x86_64-unknown-linux-gnu, GTK+ Version 3.10.8)
 of 2014-08-06 on axl
Repository revision: 117425 [email-masked]
Windowing system distributor `The X.Org Foundation', version 11.0.11501000
System Description:	Ubuntu 14.04.1 LTS